/*************************************************************
 * LangstonScreen.h
 * written by Steve Sprang
 * Copyright  1996
 *
 * Portions of this code were taken from Be's BWindowScreen
 * demo program: FullKaleid. Specifically, from KalWindow.h
 ************************************************************/
 
#ifndef LANGSTONSCREEN__H
#define LANGSTONSCREEN__H

// Index of the accelerated graphics hooks used by this demo. All of them are need,
// or the demo will not work. Currently, it works only on S3 based cards. 
#define INDEX_LINE            3
#define INDEX_RECT            5

const int	kRADIUS	= 120;

// Type definition for the graphics hooks used by this demo. 
typedef long (*LINE)(long,long,long,long,uchar,bool,short,short,short,short);
typedef long (*RECT)(long,long,long,long,uchar);

// prototypes

double distance(long, long, long, long);
static long LangstonEntry(void *);

class LangstonScreen : public BWindowScreen
{
	public:
						LangstonScreen(const char *, ulong);
						~LangstonScreen();
		virtual void	MessageReceived(BMessage *);
		virtual void	ScreenConnected(bool);
		virtual void	Quit();
				void	RandomDots();
				void	Langston();
				void	Reset();
				void	GetHooks();
						
	private:
				thread_id	draw;
				bool		**arena;
				long		width, height;
				long		x, y;
				LINE		draw_line;
				RECT		fill_rect;
};

#endif